=== debian/changelog ===
snapcast (0.23.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Remove dfsg version suffix in watch file.
  * Switch to debhelper compat level 12.
  * Build-depend on libpulse-dev.

 -- Felix Geyer <fgeyer@debian.org>  Wed, 03 Feb 2021 23:04:02 +0100
