## snapcast 0.25.0%2Bdfsg1

=== client/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #    This file is part of snapcast
-#   Copyright (C) 2014-2020  Johannes Pohl
+#   Copyright (C) 2014-2021  Johannes Pohl
 #
 #   This program is free software: you can redistribute it and/or modify
 #   it under the terms of the GNU General Public License as published by
@@ -14,7 +14,7 @@
 #   You should have received a copy of the GNU General Public License
 #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
-VERSION = 0.23.0
+VERSION = 0.25.0
 BIN = snapclient
 
 ifeq ($(TARGET), FREEBSD)
