=== debian/changelog ===
snapcast (0.25.0+dfsg1-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Felix Geyer <fgeyer@debian.org>  Wed, 22 Sep 2021 22:20:48 +0200

snapcast (0.25.0+dfsg1-2) unstable; urgency=medium

  * Fix ftbfs with GCC-11. (Closes: #984341)
    - Cherry-pick upstream patch as include_memory.hpp_for_shared_ptr.patch

 -- Felix Geyer <fgeyer@debian.org>  Fri, 10 Sep 2021 22:07:23 +0200

snapcast (0.25.0+dfsg1-1) unstable; urgency=medium

  [ Felix Geyer ]
  * New upstream release.

  [ Debian Janitor ]
  * Bump debhelper from old 12 to 13.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Felix Geyer <fgeyer@debian.org>  Wed, 08 Sep 2021 11:59:38 +0200
