## snapcast 0.25.0+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,17 +1,32 @@
 cmake_minimum_required(VERSION 3.2)
 
-project(snapcast LANGUAGES CXX VERSION 0.23.0)
+project(snapcast LANGUAGES CXX VERSION 0.25.0)
 set(PROJECT_DESCRIPTION "Multiroom client-server audio player")
 set(PROJECT_URL "https://github.com/badaix/snapcast")
 
 option(BUILD_SHARED_LIBS "Build snapcast in a shared context" ON)
 option(BUILD_STATIC_LIBS "Build snapcast in a static context" ON)
-option(BUILD_TESTS "Build tests (run tests with make test)" ON)
+option(BUILD_TESTS "Build tests (in test/snapcast_test)" ON)
 option(WERROR "Treat warnings as errors" OFF)
 
 option(ASAN "Enable AddressSanitizer" OFF)
 option(TSAN "Enable ThreadSanitizer" OFF)
 option(UBSAN "Enable UndefinedBehaviorSanitizer" OFF)
+
+option(TIDY "Enable clang tidy" OFF)
+
+IF (REVISION)
+    # add_compile_definitions(REVISION=\"${REVISION}\")
+    add_definitions(-DREVISION=\"${REVISION}\")
+ENDIF()
+
+IF (TIDY)
+    FIND_PROGRAM(CLANG_TIDY "clang-tidy")
+    IF(CLANG_TIDY)
+        set(CMAKE_CXX_CLANG_TIDY "clang-tidy;-checks=*,-readability-braces-around-statements,-hicpp-braces-around-statements,-google-readability-braces-around-statements,-hicpp-no-array-decay,-fuchsia-default-arguments-calls,-modernize-use-trailing-return-type,-cppcoreguidelines-pro-bounds-array-to-pointer-decay,-cppcoreguidelines-avoid-magic-numbers,-readability-magic-numbers,-bugprone-lambda-function-name,-hicpp-signed-bitwise,-cert-err60-cpp,-cppcoreguidelines-pro-type-reinterpret-cast,-cppcoreguidelines-pro-bounds-pointer-arithmetic,-cppcoreguidelines-init-variables,-cppcoreguidelines-no-malloc,-hicpp-no-malloc,-google-readability-todo,-modernize-pass-by-value,-cppcoreguidelines-pro-type-member-init,-hicpp-member-init,-hicpp-avoid-c-arrays,-cppcoreguidelines-avoid-c-arrays,-modernize-avoid-c-arrays,-abseil-string-find-startswith,-google-build-using-namespace,-cppcoreguidelines-owning-memory,-readability-else-after-return,-cppcoreguidelines-pro-type-vararg,-hicpp-vararg,-readability-isolate-declaration")
+        # set(CMAKE_CXX_CLANG_TIDY "clang-tidy;-checks=-*,performance-move-const-arg,modernize-use-nullptr,google-runtime-int;-fix")
+    ENDIF()
+ENDIF()
 
 if (MSVC)
     # warning level 4 and all warnings as errors
@@ -279,6 +294,7 @@
     add_definitions("-DHAS_OPENSL")
     add_definitions("-DHAS_FLAC")
     add_definitions("-DHAS_OGG")
+    add_definitions("-DHAS_OPUS")
     add_definitions("-DHAS_SOXR")
     add_definitions("-DHAS_TREMOR")
 endif()
@@ -327,6 +343,9 @@
     add_subdirectory(client)
 endif()
 
+if (BUILD_TESTS)
+    add_subdirectory(test)
+endif (BUILD_TESTS)
 
 FIND_PROGRAM(CLANG_FORMAT "clang-format")
 IF(CLANG_FORMAT)
@@ -349,3 +368,4 @@
         COMMENT "Auto formatting of all source files"
     )
 ENDIF()
+
