=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: sound
 Priority: optional
 Maintainer: Felix Geyer <fgeyer@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                libasound2-dev,
                libvorbis-dev,
                libflac-dev,
