=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/snapcast-$1\.tar\.gz/, \
  dversionmangle=auto" \
  https://github.com/badaix/snapcast/tags .*/v?(\d\S+)\.tar\.gz
